<script lang="ts">
  import { onMount, createEventDispatcher, afterUpdate } from 'svelte'
  import { ExtendedFilePicker } from '../classes/extended-file-picker'
  import { DATA_SOURCE_MAP } from '../helpers/data-source'
  import { FileMeta } from '../types'
  import { isUrl, isJson } from '../utils'

  const dispatch = createEventDispatcher()

  const stringifyStyle = (style: object) =>
    Object.entries(style)
      .map(([k, v]) => `${k}:${v};`)
      .join('')

  const spanStyle = {
    position: 'absolute',
    left: 0,
    'font-family': 'arial',
    'background-color': '#333',
    color: '#fff',
    padding: '4.5px 6px',
    'border-radius': '3px 0 0 3px',
    'white-space': 'pre',
  }

  const defaultData: FileMeta = { path: '', activeSource: '', bucket: null }

  export let name: string = ''
  export let type: FilePicker.Type | undefined = undefined
  export let value: string

  let field: HTMLInputElement
  let tag: HTMLSpanElement
  let picker: ExtendedFilePicker

  onMount(() => {
    const options: Partial<FilePicker.Options> = { field, type }
    picker = new ExtendedFilePicker(options)
  })

  const onchange = (e: Event) => {
    value = field.value
    dispatch('change', e)
  }

  const onclick = () => {
    picker.render(true)
  }

  let tagWidth: number = 20

  $: data = isJson(value) ? ({ ...defaultData, ...JSON.parse(value) } as FileMeta) : defaultData
  $: path = data.bucket && !isUrl(data.path) ? `${data.bucket}:/${data.path}` : data.path
  $: sourceTag = DATA_SOURCE_MAP[data.activeSource] || '&nbsp;&nbsp;'

  afterUpdate(() => {
    if (tagWidth != tag?.offsetWidth) {
      tagWidth = tag ? tag.offsetWidth : 20
    }
  })

  $: inputStyle = `padding-left: calc(${tagWidth}px + 0.3rem)`
</script>

<div style="position: relative;">
  <input bind:this="{field}" name="{name}" bind:value on:change="{onchange}" type="hidden" />
  <input
    style="{inputStyle}"
    data-bucket="{data.bucket}"
    data-source="{data.activeSource}"
    type="text"
    value="{path}"
    readonly
  />
  <span bind:offsetWidth="{tagWidth}" bind:this="{tag}" style="{stringifyStyle(spanStyle)}">{@html sourceTag}</span>
</div>
<button on:click="{onclick}" type="button" class="file-picker" title="Pick File"
  ><i class="fas fa-file-import fa-fw"></i></button
>
